<?php
/**
*
* @package - Top Attachments MOD
* @author all4phone
* @version $Id$
* @file				topa.php
* @copyright (c) 2014 all4phone (http://phpbbmods.cba.pl/)
* @license http://opensource.org/licenses/gpl-license.php GNU Public License 
* Note: Data base query based on 4_seven's Last X [attachments] on Forum MOD
*/

/**
* @ignore
*/

if (!defined('IN_PHPBB'))
{
	exit;
}

// Settings ---------------
$max_attach  = $config['topa_quant'];
$forums_id = $config['topa_forums'];
$how_long_title = $config['topa_cut_title'];
$how_long_file = $config['topa_cut_file'];
// Settings ---------------
//
$ext_array = array('zip');

$forums = ($forums_id) ? $forums_id : 0;
	
$forum_ary = array();
$forum_read_ary = $auth->acl_getf('f_read');

foreach ($forum_read_ary as $forum_id => $allowed){
if ($allowed['f_read']){
$forum_ary[] = (int) $forum_id;}}


$forum_ary = array_intersect(array_keys($auth->acl_getf('f_read', true)), array_keys($auth->acl_getf('f_download', true)));
if (!empty($forum_ary)){	
	$sql = 'SELECT a.*, f.*, t.*, u.*
		FROM ' . ATTACHMENTS_TABLE . ' a, ' . FORUMS_TABLE . ' f, ' . TOPICS_TABLE . ' t, ' . USERS_TABLE . ' u
		WHERE a.download_count >= 0
		AND f.forum_id = ' . $forum_id . '
		AND a.topic_id = t.topic_id
		AND a.attach_id > 0
		AND ' . $db->sql_in_set('t.forum_id', $forum_ary) . '
		AND ' . $db->sql_in_set('a.extension', $ext_array) . '
		AND t.forum_id IN (' . $forums . ')
		AND u.user_id = a.poster_id
		ORDER BY a.download_count DESC, a.filesize DESC';
	$result = $db->sql_query_limit($sql,$max_attach);
//	$row = $db->sql_fetchrow($result);

		
while ($row = $db->sql_fetchrow($result)){

	$post_link = append_sid("{$phpbb_root_path}viewtopic.$phpEx", 'f=' . $row['forum_id'] . '&amp;t=' . $row['topic_id'] . '&amp;p=' . $row['post_msg_id']) . '#p' . $row['post_msg_id'];
	$username = get_username_string('full', $row['user_id'], $row['username'], $row['user_colour'], $row['username_clean']);
	$topic_title = $row['topic_title'];
	$attach_name = substr($row['real_filename'], 0, strrpos($row['real_filename'], '.'));
	
	if ($row)
	{
		$template->assign_vars(array(
			'NUMBER_OF_ATTACH' => $max_attach
			)
		);
	}

	$template->assign_block_vars('forum_attach', array(
		'ATTACH_LINK'       => $post_link,
		'ATTACH_NAME'		=> cut_file(($attach_name),$how_long_file),
		'ATTACH_EXT'		=> '.' .$row['extension'],
		'ATTACH_TOTAL'		=> $row['download_count'],
		'ATTACH_POSTER'		=> $username,
		'ATTACH_SIZE'		=> get_formatted_filesize($row['filesize']),
		'ATTACH_VOLUME'     => get_formatted_filesize($row['download_count'] * $row['filesize']),
		'ATTACH_TITLE' 		=> cut_title(censor_text($topic_title),$how_long_title),
	));
}
$db->sql_freeresult($result);
}
?>